--[[
	
	This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License. 
	To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/2.5/ or send 
	a letter to Creative Commons, 543 Howard Street, 5th Floor, San Francisco, California, 94105, USA.
	
]]


tcPlayerFrame_Variables = {
	["decoration"] = "Normal"
};

tcPlayerFrame_TextTemplates = {
	["MinPercent"] = "0%",
	["MinValue"] = "0",
	["CurrentPercent"] = "CurrentPercent%",
	["CurrentValue"] = "CurrentValue",
	["MaxPercent"] = "100%",
	["MaxValue"] = "MaxValue",
	["MissingPercent"] = "-MissingPercent%",
	["MissingValue"] = "-MissingValue",	
	["CurrentValueMaxValue"] = "CurrentValue/MaxValue",	
	["MissingValueMaxValue"] = "-MissingValue/MaxValue",
}


tcPlayerFrame_Captions = {
	["HealthBar_Outside"] = {
		["visible"] = 1,
		["fontsize"] = 17,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "CurrentValueMaxValue",
	},
	["HealthBar_Left"] = {
		["fontsize"] = 12,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "MinPercent",
	},
	["HealthBar_Center"] = {
		["visible"] = 1,
		["fontsize"] = 12,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "CurrentPercent",
	},
	["HealthBar_Right"] = {
		["visible"] = 1,
		["fontsize"] = 12,
		["color"] = {
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		},
		["template"] = "MissingPercent",
	},
	
	["ManaBar_Outside"] = {
		["visible"] = 1,
		["fontsize"] = 12,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "CurrentValueMaxValue",
	},
	["ManaBar_Left"] = {
		["fontsize"] = 10,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "MinPercent",
	},
	["ManaBar_Center"] = {
		["visible"] = 1,
		["fontsize"] = 10,
		["color"] = {
			["r"] = 1,
			["g"] = 1,
			["b"] = 1,
		},
		["template"] = "CurrentPercent",
	},
	["ManaBar_Right"] = {
		["visible"] = 1,
		["fontsize"] = 10,
		["color"] = {
			["r"] = 1,
			["g"] = 0,
			["b"] = 0,
		},
		["template"] = "MissingPercent";
	},
}


tcPlayerFrame_Decorations = {
	["Normal"] = {
		["left"] = 0,
		["right"] = 0.5,
		["top"] = 0,
		["bottom"] = 0.38671875,
		["leftmargin"] = -19,
		["texture"] = "Interface\\AddOns\\tcPlayerFrame\\PlayerFrame",
	},
	["Plus"] = {
		["left"] = 0,
		["right"] = 0.5,
		["top"] = 0.38671875,
		["bottom"] = 0.7734375,
		["leftmargin"] = -19,
		["texture"] = "Interface\\AddOns\\tcPlayerFrame\\PlayerFrame",
	},
	["Rare"] = {
		["left"] = 0.5,
		["right"] = 1,
		["top"] = 0.38671875,
		["bottom"] = 0.7734375,
		["leftmargin"] = -8,
		["texture"] = "Interface\\AddOns\\tcPlayerFrame\\PlayerFrame",
	},
	["Elite"] = {
		["left"] = 0.5,
		["right"] = 1,
		["top"] = 0,
		["bottom"] = 0.38671875,
		["leftmargin"] = 8,
		["texture"] = "Interface\\AddOns\\tcPlayerFrame\\PlayerFrame",
	},
}



function tcPlayerFrameInitialize()
	PlayerFrameTexture:Hide();
	
	PlayerFrameBackground:SetWidth(168);
	PlayerFrameBackground:SetHeight(44);
	PlayerFrameBackground:ClearAllPoints();
	PlayerFrameBackground:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 107, -24);
	
	PlayerFrame:SetWidth(280);
	PlayerFrame:SetHeight(100);
	
	PlayerFrameHealthBar:SetWidth(167);
	PlayerFrameHealthBar:SetHeight(15);
	PlayerFrameHealthBar:ClearAllPoints();
	PlayerFrameHealthBar:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 108, -43);
	
	PlayerFrameManaBar:SetWidth(167);
	PlayerFrameManaBar:SetHeight(10);
	PlayerFrameManaBar:ClearAllPoints();
	PlayerFrameManaBar:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 108, -58);
	
	TargetFrame:ClearAllPoints();
	TargetFrame:SetPoint("TOPLEFT", "PlayerFrame", "TOPRIGHT", 90, 0);
	
	PlayerLevelText:ClearAllPoints();
	PlayerLevelText:SetPoint("CENTER", "PlayerFrame", "TOPLEFT", 52, -65);
	
	PetFrame:ClearAllPoints();
	PetFrame:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 82, -64);
	
	PlayerStatusTexture:SetTexture("Interface\\AddOns\\tcPlayerFrame\\PlayerStatus");
	PlayerStatusTexture:SetWidth(255);
	PlayerStatusTexture:SetTexCoord(0, 1, 0, 0.5234375);
	
	PlayerName:SetWidth(123);
	
	PlayerLeaderIcon:ClearAllPoints();
	PlayerLeaderIcon:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 112, -24);
	
	PlayerMasterIcon:ClearAllPoints();
	PlayerMasterIcon:SetPoint("TOPLEFT", "PlayerFrame", "TOPLEFT", 255, -24);
	
	PlayerFrameHealthBarText:ClearAllPoints();
	PlayerFrameHealthBarText:SetPoint("BOTTOMRIGHT", "UIParent", "TOPLEFT", 0, 0);
	
	PlayerFrameManaBarText:ClearAllPoints();
	PlayerFrameManaBarText:SetPoint("BOTTOMRIGHT", "UIParent", "TOPLEFT", 0, 0);
end




function tcPlayerFrame_OnLoad()	
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	tcPlayerFrameInitialize();
end
		
function tcPlayerFrame_OnEvent(event)

	if event == "UNIT_HEALTH" and arg1 == "player" then
		tcPlayerFrame_UpdateHealthTexts();
	elseif (event == "UNIT_MANA" or event == "UNIT_ENERGY" or event == "UNIT_RAGE") and arg1 == "player" then
		tcPlayerFrame_UpdateManaTexts();	
	elseif event == "VARIABLES_LOADED" then
		tcPlayerFrame_UpdateDecoration();		
	elseif event == "PLAYER_ENTERING_WORLD" then
		tcPlayerFrame_UpdateCaptions();
	end
end


function tcPlayerFrame_UpdateHealthTexts()
	local Values = { }
	Values["CurrentValue"] = UnitHealth("player"); 
	Values["MaxValue"] = UnitHealthMax("player");
	Values["CurrentPercent"] = ceil(Values["CurrentValue"] / Values["MaxValue"] * 100);
	Values["MissingValue"] = Values["MaxValue"] - Values["CurrentValue"];
	Values["MissingPercent"] = 100 - Values["CurrentPercent"];
	
	function mapToArray(v)
		return Values[v];
	end	
	
	tcPlayerFrame_HealthBar_Outside:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["HealthBar_Outside"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_HealthBar_Left:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["HealthBar_Left"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_HealthBar_Center:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["HealthBar_Center"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_HealthBar_Right:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["HealthBar_Right"]["template"]], "([^]+)", mapToArray));
end

function tcPlayerFrame_UpdateManaTexts()
	local Values = { }
	Values["CurrentValue"] = UnitMana("player"); 
	Values["MaxValue"] = UnitManaMax("player");
	Values["CurrentPercent"] = ceil(Values["CurrentValue"] / Values["MaxValue"] * 100);
	Values["MissingValue"] = Values["MaxValue"] - Values["CurrentValue"];
	Values["MissingPercent"] = 100 - Values["CurrentPercent"];
	
	function mapToArray(v)
		return Values[v];
	end	
	
	tcPlayerFrame_ManaBar_Outside:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["ManaBar_Outside"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_ManaBar_Left:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["ManaBar_Left"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_ManaBar_Center:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["ManaBar_Center"]["template"]], "([^]+)", mapToArray));
	tcPlayerFrame_ManaBar_Right:SetText(string.gsub(tcPlayerFrame_TextTemplates[tcPlayerFrame_Captions["ManaBar_Right"]["template"]], "([^]+)", mapToArray));
end


function tcPlayerFrame_UpdateDecoration()
	tcPlayerFrame_TextureLeft:SetTexture(tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["texture"]);
	tcPlayerFrame_TextureLeft:SetTexCoord(
		tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["left"],
		tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["right"],
		tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["top"],
		tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["bottom"]
	);
	
	PlayerFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", tcPlayerFrame_Decorations[tcPlayerFrame_Variables["decoration"]]["leftmargin"], PlayerFrame:GetTop() - UIParent:GetTop());
end




function tcPlayerFrame_UpdateCaptions()
	for key in tcPlayerFrame_Captions do		
		if not tcPlayerFrame_Captions[key]["visible"] then
			getglobal("tcPlayerFrame_"..key):Hide();
		else
			getglobal("tcPlayerFrame_"..key):Show();
			getglobal("tcPlayerFrame_"..key):SetTextColor(
				tcPlayerFrame_Captions[key]["color"]["r"],
				tcPlayerFrame_Captions[key]["color"]["g"],
				tcPlayerFrame_Captions[key]["color"]["b"]
			);
			getglobal("tcPlayerFrame_"..key):SetFont("Fonts\\FRIZQT__.TTF", tcPlayerFrame_Captions[key]["fontsize"]);			
		end	
	end
	
	tcPlayerFrame_UpdateHealthTexts();
	tcPlayerFrame_UpdateManaTexts();
end










